package payment.api4cb.tx.cbfc;

import java.util.Iterator;
import java.util.List;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import payment.api4cb.tx.TxBaseRequest;
import payment.api4cb.vo.CbfcProduct;

public class Tx5650Request extends TxBaseRequest {

   private String institutionID;
   private String serialNumber;
   private String orderNo;
   private String orderDate;
   private String currency;
   private String cardType;
   private String amount;
   private String settlementFlag;
   private String domain;
   private String cardNo;
   private String cardExpireMonth;
   private String cardExpireYear;
   private String cardCVV;
   private String cardBank;
   private String ip;
   private String firstName;
   private String lastName;
   private String country;
   private String state;
   private String city;
   private String address;
   private String zip;
   private String email;
   private String phone;
   private List itemList;


   public void process() throws Exception {
      DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
      DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
      Document document = documentBuilder.newDocument();
      Element Request = document.createElement("Request");
      Element Head = document.createElement("Head");
      Element Body = document.createElement("Body");
      Element TxCode = document.createElement("TxCode");
      Element InstitutionID = document.createElement("InstitutionID");
      Element SerialNumber = document.createElement("SerialNumber");
      Element OrderNo = document.createElement("OrderNo");
      Element OrderDate = document.createElement("OrderDate");
      Element Currency = document.createElement("Currency");
      Element Amount = document.createElement("Amount");
      Element SettlementFlag = document.createElement("SettlementFlag");
      Element Domain = document.createElement("Domain");
      Element CardNo = document.createElement("CardNo");
      Element CardExpireMonth = document.createElement("CardExpireMonth");
      Element CardExpireYear = document.createElement("CardExpireYear");
      Element CardCVV = document.createElement("CardCVV");
      Element CardType = document.createElement("CardType");
      Element CardBank = document.createElement("CardBank");
      Element IP = document.createElement("IP");
      Element FirstName = document.createElement("FirstName");
      Element LastName = document.createElement("LastName");
      Element Country = document.createElement("Country");
      Element State = document.createElement("State");
      Element City = document.createElement("City");
      Element Address = document.createElement("Address");
      Element ZIP = document.createElement("ZIP");
      Element Email = document.createElement("Email");
      Element Phone = document.createElement("Phone");
      Request.setAttribute("version", "2.1");
      document.appendChild(Request);
      Request.appendChild(Head);
      Head.appendChild(InstitutionID);
      Head.appendChild(TxCode);
      Request.appendChild(Body);
      Body.appendChild(SerialNumber);
      Body.appendChild(OrderNo);
      Body.appendChild(OrderDate);
      Body.appendChild(Currency);
      Body.appendChild(Amount);
      Body.appendChild(SettlementFlag);
      Body.appendChild(Domain);
      Body.appendChild(CardNo);
      Body.appendChild(CardExpireMonth);
      Body.appendChild(CardExpireYear);
      Body.appendChild(CardCVV);
      Body.appendChild(CardType);
      Body.appendChild(CardBank);
      Body.appendChild(IP);
      Body.appendChild(FirstName);
      Body.appendChild(LastName);
      Body.appendChild(Country);
      Body.appendChild(State);
      Body.appendChild(City);
      Body.appendChild(Address);
      Body.appendChild(ZIP);
      Body.appendChild(Email);
      Body.appendChild(Phone);
      TxCode.setTextContent(this.txCode);
      InstitutionID.setTextContent(this.institutionID);
      SerialNumber.setTextContent(this.serialNumber);
      OrderNo.setTextContent(this.orderNo);
      OrderDate.setTextContent(this.orderDate);
      Currency.setTextContent(this.currency);
      Amount.setTextContent(this.amount);
      SettlementFlag.setTextContent(this.settlementFlag);
      Domain.setTextContent(this.domain);
      CardNo.setTextContent(this.cardNo);
      CardExpireMonth.setTextContent(this.cardExpireMonth);
      CardExpireYear.setTextContent(this.cardExpireYear);
      CardCVV.setTextContent(this.cardCVV);
      CardType.setTextContent(this.cardType);
      CardBank.setTextContent(this.cardBank);
      IP.setTextContent(this.ip);
      FirstName.setTextContent(this.firstName);
      LastName.setTextContent(this.lastName);
      Country.setTextContent(this.country);
      State.setTextContent(this.state);
      City.setTextContent(this.city);
      Address.setTextContent(this.address);
      ZIP.setTextContent(this.zip);
      Email.setTextContent(this.email);
      Phone.setTextContent(this.phone);
      Iterator var33 = this.itemList.iterator();

      while(var33.hasNext()) {
         CbfcProduct item = (CbfcProduct)var33.next();
         Element Item = document.createElement("Item");
         Element product = document.createElement("Product");
         Element price = document.createElement("Price");
         Element count = document.createElement("Count");
         Item.appendChild(product);
         Item.appendChild(price);
         Item.appendChild(count);
         product.setTextContent(item.getProduct());
         price.setTextContent(String.valueOf(item.getPrice()));
         count.setTextContent(String.valueOf(item.getCount()));
         Body.appendChild(Item);
      }

      this.postProcess(document, this.institutionID);
   }

   public String getInstitutionID() {
      return this.institutionID;
   }

   public void setInstitutionID(String institutionID) {
      this.institutionID = institutionID;
   }

   public String getSerialNumber() {
      return this.serialNumber;
   }

   public String getSettlementFlag() {
      return this.settlementFlag;
   }

   public void setSettlementFlag(String settlementFlag) {
      this.settlementFlag = settlementFlag;
   }

   public void setSerialNumber(String serialNumber) {
      this.serialNumber = serialNumber;
   }

   public String getOrderNo() {
      return this.orderNo;
   }

   public void setOrderNo(String orderNo) {
      this.orderNo = orderNo;
   }

   public String getOrderDate() {
      return this.orderDate;
   }

   public void setOrderDate(String orderDate) {
      this.orderDate = orderDate;
   }

   public String getCurrency() {
      return this.currency;
   }

   public void setCurrency(String currency) {
      this.currency = currency;
   }

   public String getCardType() {
      return this.cardType;
   }

   public void setCardType(String cardType) {
      this.cardType = cardType;
   }

   public String getAmount() {
      return this.amount;
   }

   public void setAmount(String amount) {
      this.amount = amount;
   }

   public List getItemList() {
      return this.itemList;
   }

   public void setItemList(List itemList) {
      this.itemList = itemList;
   }

   public String getDomain() {
      return this.domain;
   }

   public void setDomain(String domain) {
      this.domain = domain;
   }

   public String getCardNo() {
      return this.cardNo;
   }

   public void setCardNo(String cardNo) {
      this.cardNo = cardNo;
   }

   public String getCardExpireMonth() {
      return this.cardExpireMonth;
   }

   public void setCardExpireMonth(String cardExpireMonth) {
      this.cardExpireMonth = cardExpireMonth;
   }

   public String getCardExpireYear() {
      return this.cardExpireYear;
   }

   public void setCardExpireYear(String cardExpireYear) {
      this.cardExpireYear = cardExpireYear;
   }

   public String getCardCVV() {
      return this.cardCVV;
   }

   public void setCardCVV(String cardCVV) {
      this.cardCVV = cardCVV;
   }

   public String getCardBank() {
      return this.cardBank;
   }

   public void setCardBank(String cardBank) {
      this.cardBank = cardBank;
   }

   public String getIp() {
      return this.ip;
   }

   public void setIp(String ip) {
      this.ip = ip;
   }

   public String getFirstName() {
      return this.firstName;
   }

   public void setFirstName(String firstName) {
      this.firstName = firstName;
   }

   public String getLastName() {
      return this.lastName;
   }

   public void setLastName(String lastName) {
      this.lastName = lastName;
   }

   public String getCountry() {
      return this.country;
   }

   public void setCountry(String country) {
      this.country = country;
   }

   public String getState() {
      return this.state;
   }

   public void setState(String state) {
      this.state = state;
   }

   public String getCity() {
      return this.city;
   }

   public void setCity(String city) {
      this.city = city;
   }

   public String getAddress() {
      return this.address;
   }

   public void setAddress(String address) {
      this.address = address;
   }

   public String getZip() {
      return this.zip;
   }

   public void setZip(String zip) {
      this.zip = zip;
   }

   public String getEmail() {
      return this.email;
   }

   public void setEmail(String email) {
      this.email = email;
   }

   public String getPhone() {
      return this.phone;
   }

   public void setPhone(String phone) {
      this.phone = phone;
   }
}
